//+------------------------------------------------------------------+
//|                                                    SmallFunc.mqh |
//|                                                        iamgotzaa |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "iamgotzaa"
#property link      "http://www.mql5.com"
#property strict
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void assignarraymonolithic(double &arr[])
  {
   for(int i=0;i<ArraySize(arr);i++)
     {
      arr[i]=i;
     }
  }
//+------------------------------------------------------------------+
double RegressionSlope(double &x[],double &y[])
  {
   int number__=ArraySize(x);
   assignarraymonolithic(y);
   double sx=ArraySum(x);
   double sy=ArraySum(y);
   double sxy=ArraySumProduct(x,y);
   double sxx=ArraySumPower2(x);
   double beta=0;
   if((number__*sxx-MathPow(sx,2))!=0)
     {
      beta=(number__*sxy-sx*sy)/(number__*sxx-MathPow(sx,2));
     }
   return(beta);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double ArraySum(double &arr[])
  {
   double k=0;
   for(int i=0;i<ArraySize(arr);i++)
     {
      k=k+arr[i];
     }
   return(k);
  }
//+------------------------------------------------------------------+
double ArraySumPower2(double &arr[])
  {
   double k=0;
   for(int i=0;i<ArraySize(arr);i++)
     {
      k=k+MathPow(arr[i],2);
     }
   return(k);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double ArraySumProduct(double &arr_a[],double &arr_b[])
  {
   double k=0;
   if(ArraySize(arr_a)!=ArraySize(arr_b))
     {
      return(-1);
     }
   for(int i=0;i<ArraySize(arr_a);i++)
     {
      k=k+(arr_a[i]*arr_b[i]);
     }
   return(k);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void debugcomment_bool(string &commentext,bool inputval,string name)
  {
   string val="";
   if(inputval) val="true"; else val="false";
   StringAdd(commentext,"\n "+name+"="+val);
  }
//+------------------------------------------------------------------+
void debugcomment_double(string &commentext,double inputval,string name,int digitx=5)
  {
   StringAdd(commentext,"\n "+name+"="+DoubleToString(inputval,digitx));
  }
//+------------------------------------------------------------------+
void debugcomment_integer(string &commentext,int inputval,string name)
  {
   StringAdd(commentext,"\n "+name+"="+IntegerToString(inputval));
  }
//+------------------------------------------------------------------+
void debugcomment_string(string &commentext,string inputval,string name)
  {
   StringAdd(commentext,"\n "+name+"="+inputval);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string BooleanToString(bool val)
  {
   if(val)
     {
      return("TRUE");
     }
   else
     {
      return("FALSE");
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double FindAverageCost(int side,int magicnumber,string sym)
  {
   double sumxy=0;
   double sumy=0;
   double avg=-1;
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS))
        {
         if(OrderType()==side && OrderMagicNumber()==magicnumber && OrderSymbol()==sym)
           {
            sumxy=sumxy+(OrderOpenPrice()*OrderLots());
            sumy=sumy+OrderLots();
           }
        }
     }

   if(sumy>0)
     {
      avg=sumxy/sumy;
     }
   return(avg);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double FindAverageCostLive(int side,string sym)
  {
   double sumxy=0;
   double sumy=0;
   double avg=-1;
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS))
        {
         if(OrderType()==side && OrderSymbol()==sym)
           {
            sumxy=sumxy+(OrderOpenPrice()*OrderLots());
            sumy=sumy+OrderLots();
           }
        }
     }

   if(sumy>0)
     {
      avg=sumxy/sumy;
     }
   return(avg);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double HighestPoint(int timeframe,int bar=5,int startx=1)
  {
   return(iHighest(Symbol(),timeframe,MODE_HIGH,bar,startx));

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double LowestPoint(int timeframe,int bar=5,int startx=1)
  {
   return(iLowest(Symbol(),timeframe,MODE_LOW,bar,startx));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double HighestClose(int timeframe,int bar=5,int startx=1)
  {
   return(iHighest(Symbol(),timeframe,MODE_CLOSE,bar,startx));

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double LowestClose(int timeframe,int bar=5,int startx=1)
  {
   return(iLowest(Symbol(),timeframe,MODE_CLOSE,bar,startx));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double hp(int bar=5,int startx=1)
  {
   return(iHighest(Symbol(),0,MODE_HIGH,bar,startx));

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double hpx(int tfs,int bar=5,int startx=1)
  {
   return(iHighest(Symbol(),tfs,MODE_HIGH,bar,startx));

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double lp(int bar=5,int startx=1)
  {
   return(iLowest(Symbol(),0,MODE_LOW,bar,startx));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double lpx(int tfs,int bar=5,int startx=1)
  {
   return(iLowest(Symbol(),tfs,MODE_LOW,bar,startx));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double hc(int bar=5,int startx=1)
  {
   return(iHighest(Symbol(),0,MODE_CLOSE,bar,startx));

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double lc(int bar=5,int startx=1)
  {
   return(iLowest(Symbol(),0,MODE_CLOSE,bar,startx));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void stoplosswheelbarrel2(int ticket,double target,double move)
  {
   double gpoints;

   if(OrderSelect(ticket,SELECT_BY_TICKET)==true)
     {
      gpoints=OrderProfit()/(OrderLots()*MarketInfo(OrderSymbol(),MODE_LOTSIZE));
      if(OrderType()==OP_BUY)
        {
         if(OrderStopLoss()==0 || OrderStopLoss()<OrderOpenPrice())
           {
            if(gpoints>target)
              {
               bool modok=OrderModify(OrderTicket(),OrderOpenPrice(),
                                      OrderOpenPrice()+move,OrderTakeProfit(),OrderExpiration(),clrYellow);
              }
           }
         else
           {
            if(OrderStopLoss()>=OrderOpenPrice())
              {
               double safegpoints=OrderStopLoss()-OrderOpenPrice();
               if(gpoints-(safegpoints)>target)
                 {
                  bool modok=OrderModify(OrderTicket(),OrderOpenPrice(),
                                         OrderStopLoss()+move,OrderTakeProfit(),OrderExpiration(),clrYellow);
                  if(GetLastError()>0)
                    {
                     Print(__FUNCTION__,":: error modifying order");
                    }
                 }
              }
           }
        }
      if(OrderType()==OP_SELL)
        {
         if(OrderStopLoss()==0 || OrderStopLoss()>OrderOpenPrice())
           {
            if(gpoints>target)
              {
               bool modok=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-move,OrderTakeProfit(),OrderExpiration(),clrYellow);
              }
           }
         else
           {
            if(OrderStopLoss()<=OrderOpenPrice())
              {
               double safegpoints=OrderOpenPrice()-OrderStopLoss();
               if(gpoints-(safegpoints)>target)
                 {
                  bool modok=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss()-move,OrderTakeProfit(),OrderExpiration(),clrYellow);
                  if(GetLastError()>0)
                    {
                     Print(__FUNCTION__,":: error modifying order");
                    }
                 }

              }
           }
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void stoplosswheelbarrel(int ticket,double target,double move)
  {
   double gpoints;
   if(OrderSelect(ticket,SELECT_BY_TICKET)==false)
     {
      return;
     }
//gpoints=OrderProfit()/(OrderLots()*MarketInfo(OrderSymbol(),MODE_LOTSIZE));
//gpoints=Bid-OrderOpenPrice();


   double bid=SymbolInfoDouble(OrderSymbol(),SYMBOL_BID);
   double ask=SymbolInfoDouble(OrderSymbol(),SYMBOL_ASK);
   int digitx=(int)SymbolInfoInteger(OrderSymbol(),SYMBOL_DIGITS);

   if(OrderType()==OP_BUY)
     {
      gpoints=NormalizeDouble(bid-OrderOpenPrice(),digitx);
      if(OrderStopLoss()==0 || OrderStopLoss()<OrderOpenPrice())
        {
         if(gpoints>target)
           {
            bool modok=OrderModify(OrderTicket(),OrderOpenPrice(),
                                   OrderOpenPrice()+move,OrderTakeProfit(),OrderExpiration(),clrYellow);
           }
        }
      else
        {
         if(OrderStopLoss()>=OrderOpenPrice())
           {
            double safegpoints=NormalizeDouble(OrderStopLoss()-OrderOpenPrice(),digitx);
            if(gpoints-(safegpoints)>target)
              {
               bool modok=OrderModify(OrderTicket(),OrderOpenPrice(),
                                      OrderStopLoss()+move,OrderTakeProfit(),OrderExpiration(),clrYellow);
               if(GetLastError()>0)
                 {
                  Print(__FUNCTION__,":: error modifying order");
                 }
              }
           }
        }
     }
   if(OrderType()==OP_SELL)
     {
      gpoints=NormalizeDouble(OrderOpenPrice()-ask,digitx);
      if(OrderStopLoss()==0 || OrderStopLoss()>OrderOpenPrice())
        {
         if(gpoints>target)
           {
            bool modok=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-move,OrderTakeProfit(),OrderExpiration(),clrYellow);
           }
        }
      else
        {
         if(OrderStopLoss()<=OrderOpenPrice())
           {
            double safegpoints=OrderOpenPrice()-OrderStopLoss();
            if(gpoints-(safegpoints)>target)
              {
               bool modok=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss()-move,OrderTakeProfit(),OrderExpiration(),clrYellow);
               if(GetLastError()>0)
                 {
                  Print(__FUNCTION__,":: error modifying order");
                 }
              }

           }
        }
     }
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int nakedbuy(int __MN,double lot)
  {
   int t=OrderSend(NULL,OP_BUY,lot,Ask,2,0,0,NULL,__MN,0,clrBlue);
   return(t);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int nakedbuy(int __MN,double lot,double __stoploss,double __takeprofit)
  {
   __stoploss=NormalizeDouble(__stoploss,Digits);
   __takeprofit=NormalizeDouble(__takeprofit,Digits);
   int t=0;
   if(__stoploss==0 || __stoploss<Ask)
     {
      if(__takeprofit==0 || __takeprofit>Ask)
        {
         t=OrderSend(NULL,OP_BUY,lot,Ask,2,__stoploss,__takeprofit,NULL,__MN,0,clrBlue);
        }
     }

   return(t);

  }
//+------------------------------------------------------------------+
int nakedsell(int __MN,double lot)
  {
   int t=OrderSend(NULL,OP_SELL,lot,Bid,2,0,0,NULL,__MN,0,clrPink);
   return(t);
  }
//+------------------------------------------------------------------+
int nakedsell(int __MN,double lot,double __stoploss,double __takeprofit)
  {
   __stoploss=NormalizeDouble(__stoploss,Digits);
   __takeprofit=NormalizeDouble(__takeprofit,Digits);
   int t=0;
   if(__stoploss==0 || __stoploss>Bid)
     {
      if(__takeprofit==0 || __takeprofit<Bid)
        {
         t=OrderSend(NULL,OP_SELL,lot,Bid,2,0,0,NULL,__MN,0,clrPink);
        }
     }
   return(t);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int nakedPending(int __MN,double lot,int side,double price,datetime exptime)
  {
   int t=OrderSend(NULL,side,lot,price,2,0,0,NULL,__MN,exptime,clrGray);
   return(t);
  }
//+------------------------------------------------------------------+
int naked(int side,int __MN,double lot)
  {
   if(side==OP_BUY)
     {
      return(nakedbuy(__MN,lot));
     }
   else if(side==OP_SELL)
     {
      return(nakedsell(__MN,lot));
     }
   else return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double AverageBarSize(int timeframe,int bar)
  {
   double val=0;
   double retval=0;
   double __open,__close;
   double firstopen,lastclose;
   firstopen=iOpen(NULL,timeframe,bar);
   lastclose=iClose(NULL,timeframe,1);
   double dir=0;
   if(firstopen>lastclose)
     {
      dir=1;
     }
   else
     {
      dir=-1;
     }
   for(int i=0;i<bar;i++)
     {
      __open=iOpen(NULL,timeframe,i);
      __close=iClose(NULL,timeframe,i);
      val=val+(__close-__open);
     }
   if(bar<0)
     {
      return(-1);
     }
   retval=dir*(val/bar);
   return(retval);
  }
//+------------------------------------------------------------------+
bool isSwifty(int tfs,int bar,double limit_point,double YieldDistancePercent=0.6)
  {
   double high,low;
   bool yes=false;
   bool retval=false;
   bool mustbeMixed=false;
   double totalmove=0;

   for(int i=1;i<=bar;i++)
     {
      high=iHigh(NULL,tfs,i);
      low=iLow(NULL,tfs,i);
      double r=high-low;
      totalmove=totalmove+r;
      if(r>limit_point)
        {
         yes=true;
        }
     }
//return(yes);
//---
   double resultantMove=HighestPoint(tfs,bar,1)-LowestPoint(tfs,bar,1);
   if(yes && totalmove>0)
     {
      if(resultantMove/totalmove<YieldDistancePercent)
        {
         retval=true;
        }
     }
//---
   return(retval);
  }
//+------------------------------------------------------------------+
double _p(int points)
  {
   return(points*Point);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool AddTarget(int ticket,double additiontp)
  {
   bool modok=false;
   if(OrderSelect(ticket,SELECT_BY_TICKET) && OrderStopLoss()==0)
     {
      double tp=0;
      if(OrderType()==OP_BUY)
        {
         tp=OrderOpenPrice()+additiontp;
        }
      if(OrderType()==OP_SELL)
        {
         tp=OrderOpenPrice()-additiontp;
        }
      tp=NormalizeDouble(tp,Digits);
      if(tp!=OrderTakeProfit())
        {
         modok=OrderModify(OrderTicket(),OrderOpenPrice(),
                           OrderStopLoss(),tp,OrderExpiration());

        }

      if(GetLastError()>0)
        {
         Print(__FUNCTION__,":: error modifying order");
        }
     }
   return(modok);
  }
//+------------------------------------------------------------------+
bool AddStoploss(int ticket,double additionsl)
  {
   bool modok=false;
   if(OrderSelect(ticket,SELECT_BY_TICKET) && OrderStopLoss()==0)
     {
      double sl=0;
      if(OrderType()==OP_BUY)
        {
         sl=Ask+additionsl;
        }
      if(OrderType()==OP_SELL)
        {
         sl=Bid-additionsl;
        }
      sl=NormalizeDouble(sl,Digits);
      if(sl!=OrderStopLoss())
        {
         modok=OrderModify(OrderTicket(),OrderOpenPrice(),
                           sl,OrderTakeProfit(),OrderExpiration(),clrGray);
        }
      if(GetLastError()>0)
        {
         Print(__FUNCTION__,":: error modifying order");
        }
     }
   return(modok);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int AutomaticIDGenerate()
  {
   int retval=0;
   retval=getPairCode(Symbol());
   return(retval);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int AutomaticIDGenerate2(string symbol)
  {
   int retval=0;
   retval=getPairCode(symbol);
   return(retval);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int getCurrencyCode(string currency3alphabet)
  {
   int retValue=0;
   if(currency3alphabet=="USD")  retValue=1;
   if(currency3alphabet=="EUR")  retValue=2;
   if(currency3alphabet=="GBP")  retValue=3;
   if(currency3alphabet=="AUD")  retValue=4;
   if(currency3alphabet=="NZD")  retValue=5;
   if(currency3alphabet=="CAD")  retValue=6;
   if(currency3alphabet=="CHF")  retValue=7;
   if(currency3alphabet=="JPY")  retValue=8;
   if(currency3alphabet=="ZAR")  retValue=9;
   if(currency3alphabet=="DKK")  retValue=10;
   if(currency3alphabet=="NOK")  retValue=11;
   if(currency3alphabet=="PLN")  retValue=12;
   if(currency3alphabet=="SGD")  retValue=13;
   if(currency3alphabet=="MEX")  retValue=14;
   return(retValue);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int getPairCode(string yourSymbol)
  {
//check length of symbol
   if(StringLen(yourSymbol)!=6)
     {
      //return(0);
     }
//get first three alphabets
   string _counter=StringSubstr(yourSymbol,0,3);
//get second three alphabets
   string _base=StringSubstr(yourSymbol,3,3);
   int n1,n2;
   n1=getCurrencyCode(_base)*1000;
   n2=getCurrencyCode(_counter)*100000;
   return(n1+n2);
  }
//+------------------------------------------------------------------+
bool ConsecHigherLow(int tfs,int bar)
  {
   bool retval=true;
   double higherlow=0;
   for(int i=0;i<bar;i++)
     {
      double low=iLow(NULL,tfs,i);
      if(low>higherlow)
        {
         higherlow=low;
         retval=retval && true;
        }
      else
        {
         retval=false;
        }
     }
   return(retval);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
bool ConsecLowerHigh(int tfs,int bar)
  {
   bool retval=true;
   double LowerHigh=0;
   for(int i=0;i<bar;i++)
     {
      double high=iHigh(NULL,tfs,i);
      if(high<LowerHigh)
        {
         LowerHigh=high;
         retval=retval && true;
        }
      else
        {
         retval=false;
        }
     }
   return(retval);
  }
//+------------------------------------------------------------------+
int GetLotSizeDigits()
  {
   int retval=2;
   double minlot=MarketInfo(Symbol(),MODE_MINLOT);
   if(minlot==0.01)
     {
      return(2);
     }
   if(minlot==0.1)
     {
      return(1);
     }
   if(minlot==1 || minlot==5 || minlot==10)
     {
      return(0);
     }
   return(retval);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
double PercentileNow(int tfs=PERIOD_M5,int bar=150)
  {
   double mean=iMA(NULL,tfs,bar,0,MODE_SMA,PRICE_CLOSE,1);
   double std=iStdDev(NULL,tfs,bar,0,MODE_SMA,PRICE_CLOSE,1);
   double z=0;
   if(std>0)
     {
      z=(Bid-mean)/std;
     }
   double p=0;

   if(z<-3.4) p=0.0003;
   if(z>=-3.4 && z<-3.3) p=0.0003;
   if(z>=-3.3 && z<-3.2) p=0.0005;
   if(z>=-3.2 && z<-3.1) p=0.0007;
   if(z>=-3.1 && z<-3) p=0.001;
   if(z>=-3.0 && z<-2.9) p=0.0014;
   if(z>=-2.9 && z<-2.8) p=0.0019;
   if(z>=-2.8 && z<-2.7) p=0.0026;
   if(z>=-2.7 && z<-2.6) p=0.0036;
   if(z>=-2.6 && z<-2.5) p=0.0048;
   if(z>=-2.5 && z<-2.4) p=0.0064;
   if(z>=-2.4 && z<-2.3) p=0.0084;
   if(z>=-2.3 && z<-2.2) p=0.011;
   if(z>=-2.2 && z<-2.1) p=0.0143;
   if(z>=-2.1 && z<-2) p=0.0183;
   if(z>=-2.0 && z<-1.9) p=0.0233;
   if(z>=-1.9 && z<-1.8) p=0.0294;
   if(z>=-1.8 && z<-1.7) p=0.0367;
   if(z>=-1.7 && z<-1.6) p=0.0455;
   if(z>=-1.6 && z<-1.5) p=0.0559;
   if(z>=-1.5 && z<-1.4) p=0.0681;
   if(z>=-1.4 && z<-1.3) p=0.0823;
   if(z>=-1.3 && z<-1.2) p=0.0985;
   if(z>=-1.2 && z<-1.1) p=0.117;
   if(z>=-1.1 && z<-1.0) p=0.1379;
   if(z>=-1.0 && z<-0.9) p=0.1611;
   if(z>=-0.9 && z<-0.8) p=0.1867;
   if(z>=-0.8 && z<-0.7) p=0.2148;
   if(z>=-0.7 && z<-0.6) p=0.2451;
   if(z>=-0.6 && z<-0.5) p=0.2776;
   if(z>=-0.5 && z<-0.4) p=0.3121;
   if(z>=-0.4 && z<-0.3) p=0.3483;
   if(z>=-0.3 && z<-0.2) p=0.3859;
   if(z>=-0.2 && z<-0.1) p=0.4247;
   if(z>=-0.1 && z<0) p=0.4641;
   if(z>=0 && z<0.1) p=0.5000;
   if(z>=0.1 && z<0.2) p=0.5398;
   if(z>=0.2 && z<0.3) p=0.5793;
   if(z>=0.3 && z<0.4) p=0.6179;
   if(z>=0.4 && z<0.5) p=0.6554;
   if(z>=0.5 && z<0.6) p=0.6915;
   if(z>=0.6 && z<0.7) p=0.7257;
   if(z>=0.7 && z<0.8) p=0.758;
   if(z>=0.8 && z<0.9) p=0.7881;
   if(z>=0.9 && z<1) p=0.8159;
   if(z>=1 && z<1.1) p=0.8413;
   if(z>=1.1 && z<1.2) p=0.8643;
   if(z>=1.2 && z<1.3) p=0.8849;
   if(z>=1.3 && z<1.4) p=0.9032;
   if(z>=1.4 && z<1.5) p=0.9192;
   if(z>=1.5 && z<1.6) p=0.9332;
   if(z>=1.6 && z<1.7) p=0.9452;
   if(z>=1.7 && z<1.8) p=0.9554;
   if(z>=1.8 && z<1.9) p=0.9641;
   if(z>=1.9 && z<2) p=0.9713;
   if(z>=2 && z<2.1) p=0.9772;
   if(z>=2.1 && z<2.2) p=0.9821;
   if(z>=2.2 && z<2.3) p=0.9861;
   if(z>=2.3 && z<2.4) p=0.9893;
   if(z>=2.4 && z<2.5) p=0.9918;
   if(z>=2.5 && z<2.6) p=0.9938;
   if(z>=2.6 && z<2.7) p=0.9953;
   if(z>=2.7 && z<2.8) p=0.9965;
   if(z>=2.8 && z<2.9) p=0.9974;
   if(z>=2.9 && z<3) p=0.9981;
   if(z>=3 && z<3.1) p=0.9987;
   if(z>=3.1 && z<3.2) p=0.999;
   if(z>=3.2 && z<3.3) p=0.9993;
   if(z>=3.3 && z<3.4) p=0.9995;
   if(z>=3.4 ) p=0.9997;

   return(p*100);

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void stoplosswheelbarrelEXP(int ticket,double target,double move,double _exponent=0.92
                            )
  {
   double gpoints;

   if(OrderSelect(ticket,SELECT_BY_TICKET)==true && OrderSymbol()==Symbol())
     {
      gpoints=OrderProfit()/(OrderLots()*MarketInfo(OrderSymbol(),MODE_LOTSIZE));
      if(OrderType()==OP_BUY)
        {
         if(OrderStopLoss()==0 || OrderStopLoss()<OrderOpenPrice())
           {
            if(gpoints>target)
              {
               bool modok=OrderModify(OrderTicket(),OrderOpenPrice(),
                                      OrderOpenPrice()+move,OrderTakeProfit(),OrderExpiration(),clrYellow);
              }
           }
         else
           {
            if(OrderStopLoss()>=OrderOpenPrice())
              {
               double safegpoints=OrderStopLoss()-OrderOpenPrice();
               double movexp=MathPow(move,_exponent);
               movexp=NormalizeDouble(movexp,Digits);
               if(gpoints-(safegpoints)>MathPow(target+safegpoints,_exponent))
                 {
                  bool modok=OrderModify(OrderTicket(),OrderOpenPrice(),
                                         OrderStopLoss()+move,OrderTakeProfit(),OrderExpiration(),clrYellow);
                  if(GetLastError()>0)
                    {
                     Print(__FUNCTION__,":: error modifying order");
                    }
                 }
              }
           }
        }
      if(OrderType()==OP_SELL)
        {
         if(OrderStopLoss()==0 || OrderStopLoss()>OrderOpenPrice())
           {
            if(gpoints>target)
              {
               bool modok=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-move,OrderTakeProfit(),OrderExpiration(),clrYellow);
              }
           }
         else
           {
            if(OrderStopLoss()<=OrderOpenPrice())
              {
               double safegpoints=OrderOpenPrice()-OrderStopLoss();
               if(gpoints-(safegpoints)>MathPow(target,_exponent))
                 {
                  bool modok=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss()-move,OrderTakeProfit(),OrderExpiration(),clrYellow);
                  if(GetLastError()>0)
                    {
                     Print(__FUNCTION__,":: error modifying order");
                    }
                 }

              }
           }
        }
     }
  }
//+------------------------------------------------------------------+
int _hour(int hours)
  {
   return(hours*60*60);
  }
//+------------------------------------------------------------------+
int _minute(int minutes)
  {
   return(minutes*60);
  }
//+------------------------------------------------------------------+
double Confluence()
  {
   double confluence=0;

   double ma600=iMA(NULL,PERIOD_M15,200,0,MODE_SMA,PRICE_CLOSE,0);
   double MarketToMa600=Bid-ma600;
   double ATR24H1=iATR(NULL,PERIOD_H1,24,0);
   double ATR24D1=iATR(NULL,PERIOD_D1,24,1);
   double Std10=iStdDev(NULL,0,10,0,MODE_EMA,PRICE_CLOSE,1);
   double Std20_lead=iStdDev(NULL,0,20,0,MODE_EMA,PRICE_CLOSE,1);
   double Std20_lag=iStdDev(NULL,0,20,0,MODE_EMA,PRICE_CLOSE,5);
   double Std24H1=iStdDev(NULL,PERIOD_H1,24,0,MODE_EMA,PRICE_CLOSE,0);

   bool Lead=Std20_lead>Std20_lag;
   bool Lag=Std20_lead<Std20_lag;

   double Range5=MathAbs(HighestPoint(PERIOD_M15,5,0)-LowestPoint(PERIOD_M15,5,0));
   double coefACCEL=Range5/Std20_lag;

   bool isExtreme=Range5>200*Point;

   double ma50lag=iMA(NULL,PERIOD_M15,50,0,MODE_SMA,PRICE_CLOSE,20);
   double ma50lead=iMA(NULL,PERIOD_M15,50,0,MODE_SMA,PRICE_CLOSE,5);
   double InertMove=ma50lead-ma50lag;
//---

   bool UncertainBreakDOWN=InertMove>-_p(0);
   bool UncertainBreakUP=InertMove<_p(0);
   double d1plus=0;
   double d1minus=0;
   if(UncertainBreakDOWN) d1minus=-1;  else d1minus=0;
   if(UncertainBreakUP) d1plus=1;  else d1plus=0;
//---

   bool UncertainReverseUp=Open[96]-Close[1]>_p(1000);
   bool UncertainReverseDown=Open[96]-Close[1]<-_p(1000);

   double d2plus=0;
   double d2minus=0;
   if(UncertainReverseDown) d2minus=-1;  else d2minus=0;
   if(UncertainReverseUp) d2plus=1;  else d2plus=0;
//---

   bool ExtremePress=(High[2]-Bid)>_p(300);
   bool ExtremePush=(Ask-Low[2])>_p(300);
   double d3plus=0;
   double d3minus=0;
   if(ExtremePress) d3minus=-1;  else d3minus=0;
   if(ExtremePush) d3plus=1;  else d3plus=0;

   bool DayBullTrendOverride=false;
   bool DayBearTrendOverride=false;
   bool BullCounterOpp=false;
   bool BearCounterOpp=false;
   double Last24Hgain=iClose(NULL,PERIOD_H1,0)-iOpen(NULL,PERIOD_H1,24);

   double Last24M15gain=iClose(NULL,PERIOD_M15,0)-iOpen(NULL,PERIOD_M15,24);
   if(Last24Hgain>_p(400) && Last24Hgain<_p(900))
     {
      DayBullTrendOverride=true;
     }
   if(Last24Hgain<-_p(400) && Last24Hgain>-_p(900))
     {
      DayBearTrendOverride=true;
     }

   if(Last24Hgain<-_p(900)-(0.5*ATR24H1) || Last24M15gain<-_p(500))
     {
      BullCounterOpp=true;
     }
   if(Last24Hgain>_p(900)+(0.5*ATR24H1) || Last24M15gain>_p(500))
     {
      BearCounterOpp=true;
     }
   double d4plus=0;
   double d4minus=0;
   if(DayBearTrendOverride) d4minus=-1;  else d4minus=0;
   if(DayBullTrendOverride) d4plus=1;  else d4plus=0;

   double d5plus=0;
   double d5minus=0;
   if(BearCounterOpp) d5minus=-1;  else d5minus=0;
   if(BullCounterOpp) d5plus=1;  else d5plus=0;
//---
//exception of shooting star
   bool BullishSign=false,BearishSign=false;
   double __range=High[1]-Low[1];
   double midBody=(High[1]+Low[1])/2;
   double __close,__open;
   __close=Close[1];
   __open=Open[1];

   double p=PercentileNow(5,150);

//---
//shootingstar previous bar
   if(__range>_p(50))
     {
      BullishSign=MathAbs(__open-__close)<=0.3*__range && __close>midBody;
      BearishSign=MathAbs(__open-__close)<=0.3*__range && __close<midBody;
     }
   if(__range>_p(150))
     {
      BullishSign=__close>midBody-0.1*__range;
      BearishSign=__close<midBody+0.1*__range;
      BullishSign=__close-__open>_p(200);
      BearishSign=__open-__close>_p(200);
     }

   double d6plus=0;
   double d6minus=0;
   if(BearishSign) d6minus=-1;  else d6minus=0;
   if(BullishSign) d6plus=1;  else d6plus=0;

//    //---

   bool CalmToBreakUp=false;
   bool CalmToBreakDown=false;
   double highclose=HighestClose(PERIOD_M15,3,3);
   double lowclose=LowestClose(PERIOD_M15,3,3);
   if(highclose-lowclose<_p(250))
     {
      CalmToBreakUp=Bid>highclose;
      CalmToBreakDown=Ask<lowclose;
     }
   double d7plus=0;
   double d7minus=0;
   if(CalmToBreakDown) d7minus=-1;  else d7minus=0;
   if(CalmToBreakUp) d7plus=1;  else d7plus=0;

   bool ConsecutiveHigherLow=ConsecHigherLow(PERIOD_M15,4);
   bool COnsecutiveLowerHigh=ConsecLowerHigh(PERIOD_M15,4);

   double d8plus=0;
   double d8minus=0;
   if(COnsecutiveLowerHigh) d8minus=-1;  else d8minus=0;
   if(ConsecutiveHigherLow) d8plus=1;  else d8plus=0;

//---
//twoboxbreak
   bool twoboxbreakup=false;
   bool twoboxbreakdown=false;

   twoboxbreakdown=iClose(NULL,PERIOD_M5,0)<LowestClose(PERIOD_M15,20,3) && iClose(NULL,PERIOD_M5,0)<LowestClose(PERIOD_M15,20,25);
   twoboxbreakup=iClose(NULL,PERIOD_M5,0)>HighestClose(PERIOD_M15,20,3) && iClose(NULL,PERIOD_M5,0)>HighestClose(PERIOD_M15,20,25);
   double d9plus=0;
   double d9minus=0;
   if(twoboxbreakdown) d9minus=-1;  else d9minus=0;
   if(twoboxbreakup) d9plus=1;  else d9plus=0;

//---

   bool followbuy=false;
   bool followsell=false;
   if(Bid-LowestPoint(PERIOD_M15,30,1)>0)
     {
      followbuy=(Bid-Close[30])/(Bid-LowestPoint(PERIOD_M15,30,1))>0.7;
     }
   if(HighestPoint(PERIOD_M15,30,1)-Bid>0)
     {
      followsell=(Close[30]-Bid)/(HighestPoint(PERIOD_M15,30,1)-Bid)>0.7;
     }

   double d10plus=0;
   double d10minus=0;
   if(followsell) d10minus=-1;  else d10minus=0;
   if(followbuy) d10plus=1;  else d10plus=0;

   double w[11];
   w[0]=0; //not use
   w[1]=0.2;   //uncertain break
   w[2]=0.1;   //uncertain reverse 
   w[3]=0.1; //extreme press/push
   w[4]=0.15; //day gain/loss overide
   w[5]=0.05; //bear/bull _counter speculator
   w[6]=0.05; //bullish/bearsigh sign
   w[7]=0.1; //calm break
   w[8]=0.1; //consec high low
   w[9]=0.05; //two boxes break
   w[10]=0.1;  //follow buy sell

               //combination weight must be equal to 1.00

   confluence=confluence
              +w[1]*(d1minus+d1plus)
              +w[2]*(d2minus+d2plus)
              +w[3]*(d3minus+d3plus)
              +w[4]*(d4minus+d4plus)
              +w[5]*(d5minus+d5plus)
              +w[6]*(d6minus+d6plus)
              +w[7]*(d7minus+d7plus)
              +w[8]*(d8minus+d8plus)
              +w[9]*(d9minus+d9plus)
              +w[10]*(d10minus+d10plus);

   return(confluence);
  }
//+------------------------------------------------------------------+
double trend()
  {
   double ma1=iMA(NULL,PERIOD_M5,5,0,MODE_EMA,PRICE_CLOSE,0);
   double ma2=iMA(NULL,PERIOD_M5,10,0,MODE_EMA,PRICE_CLOSE,0);
   double ma3=iMA(NULL,PERIOD_M5,20,0,MODE_EMA,PRICE_CLOSE,0);
   double ma4=iMA(NULL,PERIOD_M5,40,0,MODE_EMA,PRICE_CLOSE,0);

   double ma5=iMA(NULL,PERIOD_M15,5,0,MODE_EMA,PRICE_CLOSE,0);
   double ma6=iMA(NULL,PERIOD_M15,10,0,MODE_EMA,PRICE_CLOSE,0);
   double ma7=iMA(NULL,PERIOD_M15,20,0,MODE_EMA,PRICE_CLOSE,0);
   double ma8=iMA(NULL,PERIOD_M15,40,0,MODE_EMA,PRICE_CLOSE,0);

   double magnitude1=0;
   double magnitude2=0;

   magnitude1=magnitude1+0.5*(ma1-ma2)+0.35*(ma2-ma3)+0.15*(ma3-ma4);
   magnitude2=magnitude2+0.5*(ma5-ma6)+0.35*(ma6-ma7)+0.15*(ma7-ma8);

   return(0.3*magnitude1+0.7*magnitude2);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double gainefficiency()
  {
   double gxe;
   if(Symbol()=="GBPUSD")  gxe=1.0;
   if(Symbol()=="EURUSD")  gxe=1.0;
   if(Symbol()=="GBPAUD")  gxe=1.8;
   if(Symbol()=="GBPNZD")  gxe=1.8;
   if(Symbol()=="GBPCAD")  gxe=1.8;
   if(Symbol()=="EURAUD")  gxe=1.8;
   if(Symbol()=="EURNZD")  gxe=2.0;
   if(Symbol()=="EURCAD")  gxe=2.0;
   else gxe=1.0;
   return(gxe);
  }
//+------------------------------------------------------------------+
//|                 PercentileSafetyLevelX                                                 |
//+------------------------------------------------------------------+
double PSLX(int orderside,int barnumber)
  {
   double ceiling=hp(barnumber);
   double floorx=lp(barnumber);
   double mkt=(Bid+Ask)/2;
   double percentile=0;
   double per_b;
   double per_s;
   string t="";
   per_b=(mkt-floorx)/(ceiling-floorx)*100;
   per_s=(ceiling-mkt)/(ceiling-floorx)*100;

   if(orderside==OP_BUY)
     {
      percentile=per_b;
     }
   if(orderside==OP_SELL)
     {
      percentile=per_s;
     }

   percentile=NormalizeDouble(percentile,2);
   return(percentile);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double MP(int cmd)
  {
   double val=-1;
   switch(cmd)
     {
      case  OP_BUY:
         val=Ask;
         break;
      case OP_SELL:
         val=Bid;
         break;
     }
   return(val);
  }
//+------------------------------------------------------------------+
double PctLVL(int side,int barnumber)
  {
   double ceiling=hp(barnumber);
   double floorx=lp(barnumber);
   double mkt=Bid;
   double percentile=0;
   double per_b;
   double per_s;
   string t="";
   per_b=(mkt-floorx)/(ceiling-floorx)*100;
   per_s=(ceiling-mkt)/(ceiling-floorx)*100;
//t="(pips)BLK"+DoubleToStr(xpips(ceiling-floorx),1);
//t=t+", PERTB"+DoubleToStr(per_b,1);
//t=t+", PERTS"+DoubleToStr(per_b,1);
   if(side==OP_BUY)
     {
      percentile=per_b;
     }
   if(side==OP_SELL)
     {
      percentile=per_s;
     }
//status(t);
   percentile=NormalizeDouble(percentile,2);
   return(percentile);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string ordtostring(int ordertype)
  {

   switch(ordertype)
     {
      case OP_BUY :
         return("OP_BUY");
         break;
      case OP_SELL :
         return("OP_SELL");
         break;
      case OP_BUYLIMIT :
         return("OP_BUYLIMIT");
         break;
      case OP_SELLLIMIT :
         return("OP_SELLLIMIT");
         break;
      case OP_BUYSTOP :
         return("OP_BUYSTOP");
         break;
      case OP_SELLSTOP :
         return("OP_SELLSTOP");
         break;
      default: return(NULL);  break;

     }

  }
//+------------------------------------------------------------------+
int MinLotDigit(string sym)
  {
   int digitx=2;
   double minlot=MarketInfo(sym,MODE_MINLOT);
   if(minlot==0.01)
     {
      digitx=2;
     }
   if(minlot==0.1)
     {
      digitx=1;
     }
   if(minlot==1)
     {
      digitx=0;
     }
   return(digitx);
  }
//+------------------------------------------------------------------+
int SECOND_HOUR(int hour)
  {
   return(hour*60*60);
  }
//+------------------------------------------------------------------+
int SECOND_MINUTE(int minute)
  {
   return(minute*60);
  }
//+------------------------------------------------------------------+
bool LastBarGreen()
  {
   if(Close[1]>Open[1])
     {
      return(true);
     }
   else
     {
      return(false);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool LastBarRed()
  {
   if(Close[1]<Open[1])
     {
      return(true);
     }
   else
     {
      return(false);
     }
  }
//+------------------------------------------------------------------+
double Trend2()
  {
   double ma1=iMA(NULL,PERIOD_H4,5,0,MODE_EMA,PRICE_CLOSE,0);
   double ma2=iMA(NULL,PERIOD_H4,10,0,MODE_EMA,PRICE_CLOSE,0);
   double ma3=iMA(NULL,PERIOD_H4,20,0,MODE_EMA,PRICE_CLOSE,0);
   double ma4=iMA(NULL,PERIOD_H4,40,0,MODE_EMA,PRICE_CLOSE,0);

   double ma5=iMA(NULL,PERIOD_D1,5,0,MODE_EMA,PRICE_CLOSE,0);
   double ma6=iMA(NULL,PERIOD_D1,10,0,MODE_EMA,PRICE_CLOSE,0);
   double ma7=iMA(NULL,PERIOD_D1,20,0,MODE_EMA,PRICE_CLOSE,0);
   double ma8=iMA(NULL,PERIOD_D1,40,0,MODE_EMA,PRICE_CLOSE,0);

   double magnitude1=0;
   double magnitude2=0;

   magnitude1=magnitude1+0.5*(ma1-ma2)+0.35*(ma2-ma3)+0.15*(ma3-ma4);
   magnitude2=magnitude2+0.5*(ma5-ma6)+0.35*(ma6-ma7)+0.15*(ma7-ma8);

   return(0.3*magnitude1+0.7*magnitude2);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Trend1()
  {
   double ma1=iMA(NULL,PERIOD_M15,5,0,MODE_EMA,PRICE_CLOSE,0);
   double ma2=iMA(NULL,PERIOD_M15,10,0,MODE_EMA,PRICE_CLOSE,0);
   double ma3=iMA(NULL,PERIOD_M15,20,0,MODE_EMA,PRICE_CLOSE,0);
   double ma4=iMA(NULL,PERIOD_M15,40,0,MODE_EMA,PRICE_CLOSE,0);

   double ma5=iMA(NULL,PERIOD_H1,5,0,MODE_EMA,PRICE_CLOSE,0);
   double ma6=iMA(NULL,PERIOD_H1,10,0,MODE_EMA,PRICE_CLOSE,0);
   double ma7=iMA(NULL,PERIOD_H1,20,0,MODE_EMA,PRICE_CLOSE,0);
   double ma8=iMA(NULL,PERIOD_H1,40,0,MODE_EMA,PRICE_CLOSE,0);

   double magnitude1=0;
   double magnitude2=0;

   magnitude1=magnitude1+0.5*(ma1-ma2)+0.35*(ma2-ma3)+0.15*(ma3-ma4);
   magnitude2=magnitude2+0.5*(ma5-ma6)+0.35*(ma6-ma7)+0.15*(ma7-ma8);

   return(0.3*magnitude1+0.7*magnitude2);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Trend0()
  {
   double ma1=iMA(NULL,PERIOD_M1,5,0,MODE_EMA,PRICE_CLOSE,0);
   double ma2=iMA(NULL,PERIOD_M1,10,0,MODE_EMA,PRICE_CLOSE,0);
   double ma3=iMA(NULL,PERIOD_M1,20,0,MODE_EMA,PRICE_CLOSE,0);
   double ma4=iMA(NULL,PERIOD_M1,40,0,MODE_EMA,PRICE_CLOSE,0);

   double ma5=iMA(NULL,PERIOD_M5,5,0,MODE_EMA,PRICE_CLOSE,0);
   double ma6=iMA(NULL,PERIOD_M5,10,0,MODE_EMA,PRICE_CLOSE,0);
   double ma7=iMA(NULL,PERIOD_M5,20,0,MODE_EMA,PRICE_CLOSE,0);
   double ma8=iMA(NULL,PERIOD_M5,40,0,MODE_EMA,PRICE_CLOSE,0);

   double magnitude1=0;
   double magnitude2=0;

   magnitude1=magnitude1+0.5*(ma1-ma2)+0.35*(ma2-ma3)+0.15*(ma3-ma4);
   magnitude2=magnitude2+0.5*(ma5-ma6)+0.35*(ma6-ma7)+0.15*(ma7-ma8);

   return(0.3*magnitude1+0.7*magnitude2);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double gap_ema()
  {
   double a0[5];
   double a1[5];
   double a2[5];
   double a3[5];
   ArrayInitialize(a0,0);
   ArrayInitialize(a1,0);
   ArrayInitialize(a2,0);
   ArrayInitialize(a3,0);
   for(int i=0;i<5;i++)
     {
      a0[i]=iMA(NULL,PERIOD_M15,5,0,MODE_EMA,PRICE_CLOSE,0);
      a1[i]=iMA(NULL,PERIOD_M15,10,0,MODE_EMA,PRICE_CLOSE,0);
      a2[i]=iMA(NULL,PERIOD_M15,20,0,MODE_EMA,PRICE_CLOSE,0);
      a3[i]=iMA(NULL,PERIOD_M15,40,0,MODE_EMA,PRICE_CLOSE,0);

     }
   double max=0;
   double min=50000;

   for(int i=0;i<5;i++)
     {
      if(a0[i]>max) max=a0[i];
      if(a1[i]>max) max=a1[i];
      if(a2[i]>max) max=a2[i];
      if(a3[i]>max) max=a3[i];

      if(a0[i]<min) min=a0[i];
      if(a1[i]<min) min=a1[i];
      if(a2[i]<min) min=a2[i];
      if(a3[i]<min) min=a3[i];
     }

   return(NormalizeDouble(max-min,Digits));
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void AddCommentLine(string yourtext,string &comment,bool newline=true)
  {

   if(newline)
     {
      comment=comment+yourtext+"\n";
     }
   else
     {
      comment=comment+yourtext+", ";
     }
  }
//+------------------------------------------------------------------+
int SymbolToIndex(string symbol)
  {
   if(symbol=="USD") return(0);
   if(symbol=="EUR") return(1);
   if(symbol=="GBP") return(2);
   if(symbol=="CHF") return(3);
   if(symbol=="JPY") return(4);
   if(symbol=="AUD") return(5);
   if(symbol=="CAD") return(6);
   if(symbol=="NZD") return(7);
   else return(-1);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string IndexToSymbol(int index)
  {
//double usd,eur,gbp,chf,jpy,aud,cad,nzd;
   switch(index)
     {
      case  0: return("USD");  break;
      case  1: return("EUR");  break;
      case  2: return("GBP");  break;
      case  3: return("CHF");  break;
      case  4: return("JPY");  break;
      case  5: return("AUD");  break;
      case  6: return("CAD");  break;
      case  7: return("NZD");  break;

      default: return("");
      break;
     }
  }
//+------------------------------------------------------------------+
int ConstantRangeBySymbol(int symIndex)
  {
   if(symIndex==1) return(166);
   if(symIndex==2) return(177);
   if(symIndex==3) return(185);
   if(symIndex==4) return(152);
   if(symIndex==5) return(174);
   if(symIndex==6) return(168);
   if(symIndex==7) return(178);
   if(symIndex==8) return(237);
   if(symIndex==9) return(278);
   if(symIndex==10) return(251);

   if(symIndex==11) return(136);
   if(symIndex==12) return(112);
   if(symIndex==13) return(254);
   if(symIndex==14) return(308);
   if(symIndex==15) return(220);
   if(symIndex==16) return(357);
   if(symIndex==17) return(287);
   if(symIndex==18) return(278);
   if(symIndex==19) return(302);
   if(symIndex==20) return(407);

   if(symIndex==21) return(200);
   if(symIndex==22) return(171);
   if(symIndex==23) return(169);
   if(symIndex==24) return(180);
   if(symIndex==25) return(175);
   if(symIndex==26) return(195);
   if(symIndex==27) return(203);
   if(symIndex==28) return(180);
   else
     {
      return(200);
     }
  }
//+------------------------------------------------------------------+
string GetSymbol_from_index(int index)
  {
   switch(index)
     {
      case 1 :        return("AUDCAD");        break;
      case 2 :        return("AUDCHF");        break;
      case 3 :        return("AUDJPY");        break;
      case 4 :        return("AUDNZD");        break;
      case 5 :        return("AUDUSD");        break;
      case 6 :        return("CADCHF");        break;
      case 7 :        return("CADJPY");        break;
      case 8 :        return("CHFJPY");        break;
      case 9 :        return("EURAUD");        break;
      case 10 :        return("EURCAD");        break;

      case 11 :        return("EURCHF");        break;
      case 12 :        return("EURGBP");        break;
      case 13 :        return("EURJPY");        break;
      case 14 :        return("EURNZD");        break;
      case 15 :        return("EURUSD");        break;
      case 16 :        return("GBPAUD");        break;
      case 17 :        return("GBPCAD");        break;
      case 18 :        return("GBPCHF");        break;
      case 19 :        return("GBPJPY");        break;
      case 20 :        return("GBPNZD");        break;

      case 21 :        return("GBPUSD");        break;
      case 22 :        return("NZDCAD");        break;
      case 23 :        return("NZDCHF");        break;
      case 24 :        return("NZDJPY");        break;
      case 25 :        return("NZDUSD");        break;
      case 26 :        return("USDCAD");        break;
      case 27 :        return("USDCHF");        break;
      case 28 :        return("USDJPY");        break;
      default:
         return(NULL);
         break;
     }
  }
//+------------------------------------------------------------------+
int GetIndex_from_symbol(string s)
  {
   if(s=="AUDCAD") return(1);
   if(s=="AUDCHF") return(2);
   if(s=="AUDJPY") return(3);
   if(s=="AUDNZD") return(4);
   if(s=="AUDUSD") return(5);
   if(s=="CADCHF") return(6);
   if(s=="CADJPY") return(7);
   if(s=="CHFJPY") return(8);
   if(s=="EURAUD") return(9);
   if(s=="EURCAD") return(10);
   if(s=="EURCHF") return(11);
   if(s=="EURGBP") return(12);
   if(s=="EURJPY") return(13);
   if(s=="EURNZD") return(14);
   if(s=="EURUSD") return(15);
   if(s=="GBPAUD") return(16);
   if(s=="GBPCAD") return(17);
   if(s=="GBPCHF") return(18);
   if(s=="GBPJPY") return(19);
   if(s=="GBPNZD") return(20);
   if(s=="GBPUSD") return(21);
   if(s=="NZDCAD") return(22);
   if(s=="NZDCHF") return(23);
   if(s=="NZDJPY") return(24);
   if(s=="NZDUSD") return(25);
   if(s=="USDCAD") return(26);
   if(s=="USDCHF") return(27);
   if(s=="USDJPY") return(28);
   else
     {
      return(0);
     }

  }
//+------------------------------------------------------------------+
color SignColor(double val)
  {
   if(val>0)
     {
      return(clrLightGreen);
     }
   else if(val<0)
     {
      return(clrLightPink);
     }
   else return(clrAntiqueWhite);
  }
//+------------------------------------------------------------------+
void GetCurrency(string yourpair,string &retBaseSymbol,string &retCounterSymbol,string prefix=NULL,string suffix=NULL)
  {
   int prefixLength=StringLen(prefix);
   int suffixLength=StringLen(suffix);
   if(prefixLength==0 && suffixLength==0)
     {
      retBaseSymbol=StringSubstr(yourpair,3,3);
      retCounterSymbol=StringSubstr(yourpair,0,3);
     }
   else
     {
      string k=StringSubstr(yourpair,prefixLength,StringLen(yourpair)-suffixLength-prefixLength);

      retBaseSymbol=StringSubstr(k,3,3);
      retCounterSymbol=StringSubstr(k,0,3);

     }
  }
//+------------------------------------------------------------------+
void OrderPlaceMarket(int _magic,string pair,int side,double lotsize,int PointStop=0,int PointProfit=0,string comment="")
  {
   double op=0,sl=0,tp=0;
   if(side==OP_BUY)
     {
      op=MarketInfo(pair,MODE_ASK);
      if(sl!=0) sl=op-PointStop*Point;
      if(tp!=0) tp=op+PointProfit*Point;

     }
   if(side==OP_SELL)
     {
      op=MarketInfo(pair,MODE_BID);
      if(sl!=0) sl=op+PointStop*Point;
      if(tp!=0) tp=op-PointProfit*Point;

     }

   int t=OrderSend(pair,side,lotsize,op,5,sl,tp,comment,_magic);
  }
//+------------------------------------------------------------------+
void modify_tp_loop(double _be)
  {
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS))
        {
         if(OrderSymbol()==Symbol())
           {
            if(OrderTakeProfit()==0 || OrderTakeProfit()!=_be)
              {
               int mod=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),_be,OrderExpiration());
              }
           }
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void modify_tp_loop2(double _be,int yourmagic,int type)
  {
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS))
        {
         if(OrderMagicNumber()==yourmagic && OrderSymbol()==Symbol() && OrderType()==type)
           {
            if(OrderTakeProfit()==0 || OrderTakeProfit()!=_be)
              {
               int mod=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),_be,OrderExpiration());
              }
           }
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void modify_sl_loop2(double _be,int yourmagic,int type)
  {
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS))
        {
         if(OrderMagicNumber()==yourmagic && OrderSymbol()==Symbol() && OrderType()==type)
           {
            if(OrderTakeProfit()==0 || OrderStopLoss()!=_be)
              {
               int mod=OrderModify(OrderTicket(),OrderOpenPrice(),_be,OrderTakeProfit(),OrderExpiration());
              }
           }
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double LastCandlePL(int tf,int index=0)
  {
   return(iClose(NULL,tf,index)-iOpen(NULL,tf,index));
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
int minutes(int minutenumber)
  {
   return(minutenumber*60);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int hours(int hournumber)
  {
   return(hournumber*60*60);
  }
//+------------------------------------------------------------------+
string time_text()
  {
   return(TimeToString(TimeCurrent(),TIME_DATE|TIME_MINUTES|TIME_SECONDS));
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int ArraySum_int(int &arr[])
  {
   int sum=0;
   for(int i=0;i<ArraySize(arr);i++)
     {
      sum=sum+arr[i];
     }
   return(sum);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void RoundPriceFinder(double &up,double &down,int side,int pointdist=200)
  {
   double __now=0;
   if(side==OP_BUY) __now=Ask;
   if(side==OP_SELL) __now=Bid;
   if(__now==0)return;
//---
//e.g. 1.78112
//1.78112 x 10^5 = 178112
//178112%200=112 << residual
//112 << subtract off
//200-112=88 << add on
//178112-112=178000
//178112+88=178200
//therefore
   int full=(int)(__now*MathPow(10,Digits));
   int res=full%pointdist;
   double retValUp=0;
   double retValDown=0;
   retValUp=(full+(pointdist-res))*MathPow(10,-Digits);
   retValDown=(full-res)*MathPow(10,-Digits);
//---
   up=retValUp;
   down=retValDown;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void RoundPriceFinderSpec(double specificprice,double &up,double &down,int side,int pointdist=200)
  {
   double __now=specificprice;

   if(__now==0)return;
//---
//e.g. 1.78112
//1.78112 x 10^5 = 178112
//178112%200=112 << residual
//112 << subtract off
//200-112=88 << add on
//178112-112=178000
//178112+88=178200
//therefore
   int full=(int)(__now*MathPow(10,Digits));
   int res=full%pointdist;
   double retValUp=0;
   double retValDown=0;
   retValUp=(full+(pointdist-res))*MathPow(10,-Digits);
   retValDown=(full-res)*MathPow(10,-Digits);
//---
   up=retValUp;
   down=retValDown;
  }
//+------------------------------------------------------------------+
double pxpip(double pricegap)
  {
   double retval=0;
   retval=pricegap*MathPow(10,Digits-1);
   return(retval);
  }
//+------------------------------------------------------------------+
string pxpipStr(double pricegap,
                int decimal=0,
                bool showunits=true)//zero or one
  {
   if(!showunits)
     {
      return(DoubleToString(pxpip(pricegap),decimal));
     }
   return(DoubleToString(pxpip(pricegap),decimal)+" pips");
  }
//+------------------------------------------------------------------+
string PriceToString(double price)
  {
   return(DoubleToString(price,Digits));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double iCloseGap(string sym,int tf,int shift)
  {
   return(iClose(sym,tf,shift)-iOpen(sym,tf,shift));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double iCloseGapAbs(string sym,int tf,int shift)
  {
   return(MathAbs(iClose(sym,tf,shift)-iOpen(sym,tf,shift)));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double iRange(string sym,int tf,int shift)
  {
   return(iHigh(sym,tf,shift)-iLow(sym,tf,shift));
  }
//+------------------------------------------------------------------+
double averageReturn(int tf,string sym,int __bars=252)
  {
   double cum=0;
   for(int i=1;i<=__bars;i++)
     {
      cum=cum+iCloseGapAbs(sym,tf,i);
      //Print(__FUNCTION__,"::",cum);
     }
   return(cum/__bars);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double averageRange(int tf,string sym,int __bars=252)
  {
   double cum=0;
   for(int i=1;i<=__bars;i++)
     {
      cum=cum+iRange(sym,tf,i);
      //Print(__FUNCTION__,"::",cum);
     }
   return(cum/__bars);
  }
//+------------------------------------------------------------------+

double RangeFind(int tf,int __bar=10)
  {
   double retVal=0;
   retVal=hpx(tf,__bar)-lpx(tf,__bar);
   return(retVal);
  }
//+------------------------------------------------------------------+
void tradesleep(int n=100)
  {
   while(IsTradeContextBusy())
     {
      Sleep(n);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool newbar(int tf)
  {
   static int mybars;
   bool yes=false;
   if(iBars(Symbol(),tf)>mybars)
     {
      mybars=iBars(Symbol(),tf);
      yes=true;
     }

   return(yes);
  }
//+------------------------------------------------------------------+
double funcSMA(int __TF,int __bars,int _ind=1)
  {
   double retVal=iMA(Symbol(),__TF,__bars,0,MODE_SMA,PRICE_CLOSE,_ind);
   return(retVal);
  }
//+------------------------------------------------------------------+
double funcSMA_MEDIAN(int __TF,int __bars,int _ind=1)
  {
   double retVal=iMA(Symbol(),__TF,__bars,0,MODE_SMA,PRICE_MEDIAN,_ind);
   return(retVal);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double PIVOT(int __TF)
  {
   double retval=0;
   retval=(iHigh(Symbol(),__TF,1)+iLow(Symbol(),__TF,1)+iClose(Symbol(),__TF,1))/3;
   retval=NormalizeDouble(retval,Digits);
   return(retval);
  }
//+------------------------------------------------------------------+
