//+------------------------------------------------------------------+
//|                                                      myfeb10.mqh |
//|                                                        iamgotzaa |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "iamgotzaa"
#property link      "https://www.mql5.com"
#property strict

#define state_idle         0
#define state_await_buy    500
#define state_await_sell    600
#define state_buy1          1000
#define state_sell1         2000
#define state_buy2          1800
#define state_sell2         2800

#define state_retain    10
#define state_spreadbuy 3000
#define state_spreadsell 4000
#define state_fishingBuy   3100
#define state_fishingSell  4100
#define state_RV_buy 5100
#define state_RV_sell 5200
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void status(string msg)
  {
   comments=comments+"  "+now+"  ::  "+msg+"\n";
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OrderAccounting()
  {
   ArrayInitialize(OrderAcc_buy,0);
   ArrayInitialize(OrderAcc_sell,0);
   int countb=0;
   int counts=0;

   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
        {
         if(OrderMagicNumber()==MAGIC)
           {
            if(OrderType()==OP_BUY)
              {
               OrderAcc_buy[countb][0]=OrderTicket();
               OrderAcc_buy[countb][1]=OrderLots();
               OrderAcc_buy[countb][2]=OrderOpenPrice();
               countb++;
              }
            if(OrderType()==OP_SELL)
              {
               OrderAcc_sell[counts][0]=OrderTicket();
               OrderAcc_sell[counts][1]=OrderLots();
               OrderAcc_sell[counts][2]=OrderOpenPrice();
               counts++;
              }
           }
        }
     }
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

double BreakEvenPrice2(int side)
  {
   double sumxy=0;
   double sumy=0;
   double weightaverage=-1;
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS))
        {
         if(OrderType()==side && OrderMagicNumber()==MAGIC && OrderSymbol()==Symbol())
           {
            sumxy=sumxy+(OrderOpenPrice()*OrderLots());
            sumy=sumy+OrderLots();
           }
        }
     }

   if(sumy>0)
     {
      weightaverage=sumxy/sumy;
     }
   return(weightaverage);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double BreakEvenPrice3(int side,int yourmagic)
  {
   double sumxy=0;
   double sumy=0;
   double weightaverage=-1;
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS))
        {
         if(OrderType()==side && OrderMagicNumber()==yourmagic && OrderSymbol()==Symbol())
           {
            sumxy=sumxy+(OrderOpenPrice()*OrderLots());
            sumy=sumy+OrderLots();
           }
        }
     }

   if(sumy>0)
     {
      weightaverage=sumxy/sumy;
     }
   return(weightaverage);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int xpips(double decimal)
  {
   return((int)(decimal*MathPow(10,Digits-1)));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void showmycomment_CurrentRange()
  {
   ATR=iATR(Symbol(),PERIOD_H1,atr_range,1);
   if(ATR<100*Point) ATR=100*Point;

   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void showmycomment_LastTicket()
  {
   pl=OAPLPips(lastticket);
   if(OrderSelect(lastticket,SELECT_BY_TICKET)==true)
     {
      ThisOpenPrice=OrderOpenPrice();
     }
   status("Last Ticket="+IntegerToString(lastticket));
   status("Profit/Loss="+DoubleToStr(pl,1)+"pips");
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void showmycomment_timeunlocked_buy()
  {
   status("Last Time Stamp="+
          TimeToStr(timestamp_buy,TIME_MINUTES)+
          ", Minutes to unlock time="+
          TimeToStr(MinutesToUnlock_buy,TIME_DATE|TIME_MINUTES)+" mins");
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void showmycomment_timeunlocked_sell()
  {
   status("Last Time Stamp="+
          TimeToStr(timestamp_sell,TIME_MINUTES)+
          ", Minutes to unlock time="+
          TimeToStr(MinutesToUnlock_sell,TIME_DATE|TIME_MINUTES)+" mins");
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void showmycomment_ListOrder_buy()
  {
   status("//------------Order List (Ticket, Lots, Price) -----------------//");
   status("// ke,Re orders count="+DoubleToString(OACount(MAGIC,OP_BUY,Symbol()),0));
//----MachineState's action
   OrderAccounting();
   for(int index=0;index<25;index++)
     {
      if(OrderAcc_buy[index][0]!=0)
        {
         status("//----  #"+IntegerToString(index)+" |"+DoubleToStr(OrderAcc_buy[index][0],0)+", "+DoubleToStr(OrderAcc_buy[index][1],2)+", "+DoubleToStr(OrderAcc_buy[index][2],Digits)+"  ----//");
        }
     }
   thisBreakEven=BreakEvenPrice2(OP_BUY);
   if(thisBreakEven-Bid>0)
     {
      distance_Loss=MathAbs(thisBreakEven-Bid)*MathPow(10,Digits-1);
      distance_Gain=0;
     }
   else if(thisBreakEven-Bid==0)
     {
      distance_Loss=0;
      distance_Gain=0;
     }
   else
     {
      distance_Loss=0;
      distance_Gain=MathAbs(thisBreakEven-Bid)*MathPow(10,Digits-1);
     }

   status("Current breakeven price="+DoubleToStr(thisBreakEven,Digits));
   status("Distance to breakeven Loss/Gain="+DoubleToStr(distance_Loss,1)+", "+DoubleToStr(distance_Gain,1));
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void showmycomment_ListOrder_sell()
  {
   status("//------------Order List (Ticket, Lots, Price) -----------------//");
   status("// ke,Re orders count="+DoubleToString(OACount(MAGIC,OP_SELL,Symbol()),0));
//----MachineState's action
   OrderAccounting();
   for(int index=0;index<25;index++)
     {
      if(OrderAcc_sell[index][0]!=0)
        {
         status("//----  #"+IntegerToString(index)+" |"+DoubleToStr(OrderAcc_sell[index][0],0)+", "+DoubleToStr(OrderAcc_sell[index][1],2)+", "+DoubleToStr(OrderAcc_sell[index][2],Digits)+"  ----//");
        }
     }
   thisBreakEven=BreakEvenPrice2(OP_SELL);
   if(thisBreakEven-Ask>0)
     {
      distance_Loss=0;
      distance_Gain=MathAbs(thisBreakEven-Ask)*MathPow(10,Digits-1);
     }
   else if(thisBreakEven-Ask==0)
     {
      distance_Loss=0;
      distance_Gain=0;
     }
   else
     {

      distance_Loss=MathAbs(thisBreakEven-Ask)*MathPow(10,Digits-1);
      distance_Gain=0;

     }

   status("Current breakeven price="+DoubleToStr(thisBreakEven,Digits));
   status("Distance to breakeven Loss/Gain="+DoubleToStr(distance_Loss,1)+", "+DoubleToStr(distance_Gain,1));
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Recovery_Close_All_buy()
  {
   bool close_done=false;
   Print(IntegerToString(MachineState)+":Recovery_Close_All_buy: Commencing closing seqeunce...");
   for(int index=0;index<25;index++)
     {
      if(OrderAcc_buy[index][0]!=0)
        {
         if(OrderSelect((int)(OrderAcc_buy[index][0]),SELECT_BY_TICKET)==true)
           {
            status("Selected Order #"+DoubleToStr(OrderAcc_buy[index][0],0)+", OK to close");
            close_done=OrderClose(OrderTicket(),OrderLots(),Bid,5,Salmon);
            while(IsTradeContextBusy())
              {
               status("Trade context is busy... (sleeping zZz)");
               Sleep(20);
              }
            if(close_done==true) Print(IntegerToString(MachineState)+":Recovery_Close_All_buy: ._closed ticket #"+
               IntegerToString(OrderTicket())+", CloseTime="+TimeToStr(OrderCloseTime(),TIME_MINUTES));
           }
        }
     }
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Recovery_Close_All_sell()
  {
   bool close_done=false;
   Print(IntegerToString(MachineState)+":Recovery_Close_All_sell: Commencing closing seqeunce...");
   for(int index=0;index<25;index++)
     {
      if(OrderAcc_sell[index][0]!=0)
        {
         if(OrderSelect((int)(OrderAcc_sell[index][0]),SELECT_BY_TICKET)==true)
           {
            status("Selected Order #"+DoubleToStr(OrderAcc_sell[index][0],0)+", OK to close");
            close_done=OrderClose(OrderTicket(),OrderLots(),Ask,5,PaleGreen);
            while(IsTradeContextBusy())
              {
               status("Trade context is busy... (sleeping zZz)");
               Sleep(20);
              }
            if(close_done==true) Print(IntegerToString(MachineState)+":Recovery_Close_All_sell: ._closed ticket #"+
               IntegerToString(OrderTicket())+", CloseTime="+TimeToStr(OrderCloseTime(),TIME_MINUTES));
           }
        }
     }
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Remove_StopLoss(int ticketnumber)
  {
//Remove stop loss price first before do martingale to recovery
   status("Remove_StopLoss: Removing stoploss on ticket #"+IntegerToString(ticketnumber));
   bool selected=false;
   if(OrderSelect(ticketnumber,SELECT_BY_TICKET))
      selected=true;
   if(OrderModify(OrderTicket(),OrderOpenPrice(),0,OrderTakeProfit(),OrderExpiration(),Gray)==true && selected)
     {
      Print(IntegerToString(MachineState)+":Remove_StopLoss: Stoploss for order #"+
            IntegerToString(ticketnumber)+" is now set to zero");
     }
   else
     {
      Print(IntegerToString(MachineState)+":Error in Remove_StopLoss: Code="+IntegerToString(GetLastError()));
     }
   return;
  }
// Trade_Market(OP_BUY,0.1,"Main",0,0,timestamp_buy);
int Trade_Market(int side,datetime &_timestamp,double lot_size,double stop_price=0,double target_price=0,string comment="")
  {
   int retTicket=0;
   if(side==OP_BUY)  retTicket=Trade_Buy(Symbol(),MAGIC,lot_size,stop_price,target_price,comment);
   if(side==OP_SELL)  retTicket=Trade_Sell(Symbol(),MAGIC,lot_size,stop_price,target_price,comment);
   _timestamp=TimeCurrent();

   if(retTicket>0)
     {
      Print(IntegerToString(MachineState)+":Trade_Market: Placed order successfully, ticket #"+IntegerToString(retTicket));
     }
   return(retTicket);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int hr_sec(int hours)
  {
   return(hours*60*60);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void RecordMaxGAINLOSS()
  {
   string t;

   if(pl>max_gain && pl>0) max_gain=pl;
   if(pl<max_loss && pl<0) max_loss=pl;

   if(max_loss!=0) RRR=MathAbs(max_gain/max_loss);  else RRR=-1;
   t="RRR"+DoubleToStr(RRR,2)+", MAXG"+DoubleToStr(max_gain,1)+", MAXL"+DoubleToStr(max_loss,1);

   status(t);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OrderOpenTooLongAndNotMove()
  {
   if(TimeCurrent()-laststamp>hr_sec(2) && TimeCurrent()-laststamp>hr_sec(8) && RRR!=0)
     {
      if(1/RRR>=1.5 && -max_loss>=10 && pl>=5)
        {
         if(OrderClose(lastticket,OrderLots(),Bid,5,DarkGray)==true)
           {
            Print("Close order#"+IntegerToString(lastticket)+", REASON:OrderOpenTooLongAndNotMove(), LOGIC1");
            if(MachineState==state_buy1) BlockBuyUntilTime=TimeCurrent()+60*60;
            if(MachineState==state_sell1) BlockSellUntilTime=TimeCurrent()+60*60;
           }
        }
     }

   if(TimeCurrent()-laststamp>hr_sec(3) && RRR!=0)
     {
      if(1/RRR>=5 && -max_loss>=10 && pl>=-20)
        {
         if(OrderClose(lastticket,OrderLots(),Bid,5,Goldenrod)==true)
           {
            Print("Close order#"+IntegerToString(lastticket)+", REASON:OrderOpenTooLongAndNotMove(), LOGIC2");
            if(MachineState==state_buy1) BlockBuyUntilTime=TimeCurrent()+60*60;
            if(MachineState==state_sell1) BlockSellUntilTime=TimeCurrent()+60*60;
           }
        }
     }

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void BuyThenImmediateProfit()
  {
   bool stochOBOS=false;
   double piptotake;
//piptotake=xpips(fastATR);
   piptotake=10;
//if(xpips(fastATR)<=10)   piptotake=5;
   if(TimeCurrent()-laststamp<hr_sec(1))
     {
      if(pl>=piptotake)
        {
         if(OrderClose(lastticket,OrderLots(),Bid,5,Olive)==true)
           {
            Print("Close order#"+IntegerToString(lastticket)+", REASON:BuyThenImmediateProfit()");
            if(MachineState==state_buy1)
              {
               BlockBuyUntilTime=TimeCurrent()+60*60;
               //MachineState=state_revbuy_tradesell;
              }
            if(MachineState==state_sell1)
              {
               BlockSellUntilTime=TimeCurrent()+60*60;
               //MachineState=state_revsell_tradebuy;
              }
           }

        }
     }

  }
//+------------------------------------------------------------------+
void LossRealizer(int yourmagic,int side,int startOrdQty,double lossPctEqty)
  {
   int c=order_count_live2(yourmagic,side);
   if(c<startOrdQty)
     {
      return;
      status(__FUNCSIG__+":: orders level is low");
     }

   double SymbolLoss=magic_profit(yourmagic)/AccountBalance()*100;

   if(SymbolLoss>-lossPctEqty)
     {
      return;
      status(__FUNCSIG__+":: loss % level is low");
     }
   status("magic loss="+DoubleToString(SymbolLoss,2)+"% (%limit)="+DoubleToString(lossPctEqty,2)+"%");

   double l[];
   int t[];
   ArrayResize(l,c);
   ArrayResize(t,c);
   double mkt;
   c=0;
   if(side==OP_BUY) mkt=Bid;
   else if(side==OP_SELL) mkt=Ask;
   double averagedistance=0;
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS))
        {
         if(OrderMagicNumber()==yourmagic && OrderSymbol()==Symbol() && OrderType()==side)
           {
            if(side==OP_BUY) l[c]=OrderOpenPrice()-mkt;
            else if(side==OP_SELL) l[c]=mkt-OrderOpenPrice();
            t[c]=OrderTicket();
            //Print("t[c]=",t[c]);
            averagedistance+=l[c];
            c++;

           }
        }
     }
   averagedistance=averagedistance/c;
   status(__FUNCSIG__+":: avg dist="+DoubleToString(averagedistance,Digits));
   for(int i=0;i<c;i++)
     {
      if(OrderSelect(t[i],SELECT_BY_TICKET))
        {
         double minlot=MarketInfo(OrderSymbol(),MODE_MINLOT);
         status(__FUNCSIG__+":: dist"+IntegerToString(i)+"="+DoubleToString(OrderOpenPrice()-mkt,Digits));
         bool buyDeduceCheck=OrderType()==OP_BUY && OrderOpenPrice()-mkt>averagedistance;
         bool sellDeduceCheck=OrderType()==OP_SELL && mkt-OrderOpenPrice()>averagedistance;
         if(OrderLots()/2<=minlot)
           {
            if(buyDeduceCheck)close_order_immediate(OrderTicket());
            if(sellDeduceCheck)close_order_immediate(OrderTicket());
           }
         else if(OrderLots()/2>minlot)
           {
            double lotdeduce=LegalizeLotSize(OrderLots()/2);
            double sbid=MarketInfo(OrderSymbol(),MODE_BID);
            double sask=MarketInfo(OrderSymbol(),MODE_ASK);
            if(lotdeduce>minlot)
              {
               if(buyDeduceCheck)
                 {
                  bool closeok=OrderClose(OrderTicket(),lotdeduce,sbid,2,clrBeige);
                  if(closeok)
                    {
                     status("Deducing "+IntegerToString(OrderTicket())+" by "+DoubleToString(lotdeduce,2));
                    }
                 }
               if(sellDeduceCheck)
                 {
                  bool closeok=OrderClose(OrderTicket(),lotdeduce,sask,2,clrBeige);
                  if(closeok)
                    {
                     status("Deducing "+IntegerToString(OrderTicket())+" by "+DoubleToString(lotdeduce,2));
                    }
                 }
              }

           }
        }//select order ok
     }//for loop
  }
//+------------------------------------------------------------------+
void Sensing_v1(int n,int move_points,int &gainbars,int &losebars)
  {
//reset
   gainbars=0;
   losebars=0;
   for(int i=0;i<n;i++)
     {
      if(Close[i]>Close[i+1]+move_points*Point)gainbars++;
      else if(Close[i]<Close[i+1]-move_points*Point)losebars++;
     }
  }
//+------------------------------------------------------------------+
